## osmium-tool 1.9.1

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")


#-----------------------------------------------------------------------------
#
#  Project version
#
#-----------------------------------------------------------------------------

# It is important that this setting remains before the "project" call.
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo;MinSizeRel;Dev"
    CACHE STRING
    "List of available configuration types"
    FORCE)

project(osmium)

set(OSMIUM_VERSION_MAJOR 1)
set(OSMIUM_VERSION_MINOR 9)
set(OSMIUM_VERSION_PATCH 1)

set(OSMIUM_VERSION ${OSMIUM_VERSION_MAJOR}.${OSMIUM_VERSION_MINOR}.${OSMIUM_VERSION_PATCH})

set(AUTHOR "Jochen Topf <jochen@topf.org>")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)


#-----------------------------------------------------------------------------
#
#  Find external dependencies
#
#-----------------------------------------------------------------------------

find_package(Boost 1.55.0 REQUIRED COMPONENTS program_options)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

find_package(Osmium 2.14.2 REQUIRED COMPONENTS io)
include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS})


#-----------------------------------------------------------------------------
#
#  Optional "cppcheck" target that checks C++ code
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for cppcheck")
find_program(CPPCHECK cppcheck)

if(CPPCHECK)
    message(STATUS "Looking for cppcheck - found")
    set(CPPCHECK_OPTIONS --enable=warning,style,performance,portability,information,missingInclude)

    # cpp doesn't find system includes for some reason, suppress that report
    set(CPPCHECK_OPTIONS ${CPPCHECK_OPTIONS} --suppress=missingIncludeSystem)

    add_custom_target(cppcheck ${CPPCHECK} --std=c++11 ${CPPCHECK_OPTIONS} ${CMAKE_SOURCE_DIR}/src/*pp)
else()
    message(STATUS "Looking for cppcheck - not found")
    message(STATUS "  Build target 'cppcheck' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "iwyu" target to check headers
#  https://include-what-you-use.org/
#
#-----------------------------------------------------------------------------
find_program(IWYU_TOOL NAMES iwyu_tool iwyu_tool.py)

if(IWYU_TOOL)
    message(STATUS "Looking for iwyu_tool.py - found")
    add_custom_target(iwyu ${IWYU_TOOL} -p ${CMAKE_BINARY_DIR} -- --mapping_file=${CMAKE_SOURCE_DIR}/iwyu.imp)
else()
    message(STATUS "Looking for iwyu_tool.py - not found")
    message(STATUS "  Make target 'iwyu' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Decide which C++ version to use (Minimum/default: C++11).
#
#-----------------------------------------------------------------------------
if(NOT MSVC)
    if(NOT USE_CPP_VERSION)
        set(USE_CPP_VERSION c++11)
    endif()
    message(STATUS "Use C++ version: ${USE_CPP_VERSION}")
    # following only available from cmake 2.8.12:
    #   add_compile_options(-std=${USE_CPP_VERSION})
    # so using this instead:
    add_definitions(-std=${USE_CPP_VERSION})
endif()


#-----------------------------------------------------------------------------
#
#  Compiler and Linker flags
#
#-----------------------------------------------------------------------------
if(MSVC)
    set(USUAL_COMPILE_OPTIONS "/Ox")
else()
    set(USUAL_COMPILE_OPTIONS "-O3 -g")
endif()

if(WIN32)
    add_definitions(-DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32)
endif()

set(CMAKE_CXX_FLAGS_DEV "${USUAL_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during developer builds."
    FORCE)

set(CMAKE_EXE_LINKER_FLAGS_DEV ""
    CACHE STRING "Flags used by the linker during developer builds."
    FORCE)
mark_as_advanced(
    CMAKE_CXX_FLAGS_DEV
    CMAKE_EXE_LINKER_FLAGS_DEV
)

set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${USUAL_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during RELWITHDEBINFO builds."
    FORCE)


#-----------------------------------------------------------------------------
#
#  Build Type
#
#-----------------------------------------------------------------------------

add_definitions(${OSMIUM_WARNING_OPTIONS})

# In 'Dev' mode: compile with very strict warnings and turn them into errors.
if(CMAKE_BUILD_TYPE STREQUAL "Dev")
    if(NOT MSVC)
        add_definitions(-Werror)
    endif()
endif()

# Force RelWithDebInfo build type if none was given
if(CMAKE_BUILD_TYPE)
    set(build_type ${CMAKE_BUILD_TYPE})
else()
    set(build_type "RelWithDebInfo")
endif()

set(CMAKE_BUILD_TYPE ${build_type}
    CACHE STRING
    "Choose the type of build, options are: ${CMAKE_CONFIGURATION_TYPES}."
    FORCE)

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")


#-----------------------------------------------------------------------------
#
#  Version
#
#-----------------------------------------------------------------------------

find_package(Git)

if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                    OUTPUT_VARIABLE VERSION_FROM_GIT
                    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(VERSION_FROM_GIT)
        set(VERSION_FROM_GIT " (${VERSION_FROM_GIT})")
    endif()
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/src/version.cpp.in
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

#-----------------------------------------------------------------------------

configure_file(
    ${PROJECT_SOURCE_DIR}/osmium-wrapper.in
    ${PROJECT_BINARY_DIR}/osmium
)

include_directories(SYSTEM include)
include_directories(${PROJECT_BINARY_DIR}/src)

#-----------------------------------------------------------------------------

SET(OSMIUM_COMMANDS
    add-locations-to-ways
    apply-changes
    cat
    changeset-filter
    check-refs
    derive-changes
    diff
    export
    extract
    fileinfo
    getid
    getparents
    merge
    merge-changes
    renumber
    show
    sort
    tags-filter
    time-filter
)

set(OSMIUM_SOURCE_FILES
    cmd.cpp
    cmd_factory.cpp
    id_file.cpp
    io.cpp
    util.cpp
    command_help.cpp
    export/export_format_json.cpp
    export/export_format_text.cpp
    export/export_handler.cpp
    extract/extract_bbox.cpp
    extract/extract.cpp
    extract/extract_polygon.cpp
    extract/geojson_file_parser.cpp
    extract/osm_file_parser.cpp
    extract/poly_file_parser.cpp
    extract/strategy_complete_ways.cpp
    extract/strategy_complete_ways_with_history.cpp
    extract/strategy_simple.cpp
    extract/strategy_smart.cpp
)

foreach(_command ${OSMIUM_COMMANDS})
    string(REPLACE "-" "_" _ucmd ${_command})
    list(APPEND OSMIUM_SOURCE_FILES "command_${_ucmd}.cpp")
endforeach()

add_subdirectory(man)
add_subdirectory(src)


#-----------------------------------------------------------------------------
#
#  Tests
#
#-----------------------------------------------------------------------------

enable_testing()
add_subdirectory(test)

#-----------------------------------------------------------------------------
#
#  Optional "clang-tidy" target
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for clang-tidy")
find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-6.0 clang-tidy-5.0)

if(CLANG_TIDY)
    message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")

    file(GLOB _unit_tests RELATIVE "${CMAKE_SOURCE_DIR}/src" "${CMAKE_SOURCE_DIR}/test/*/*.cpp")

    add_custom_target(clang-tidy
        ${CLANG_TIDY}
        -p ${CMAKE_BINARY_DIR}
        ${OSMIUM_SOURCE_FILES} ${_unit_tests}
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src"
    )
else()
    message(STATUS "Looking for clang-tidy - not found")
    message(STATUS "  Build target 'clang-tidy' will not be available.")
endif()

#-----------------------------------------------------------------------------
#
#  Test install
#
#  Does a local install and checks that the files we expect to be installed
#  are installed and no extra files are installed. If this fails make sure
#  the list of files in cmake/test_install.cmake is correct. Only enables
#  if the WITH_EXTRA_TESTS option is set, because this test fails on some
#  platforms even if everything is correct.
#
#-----------------------------------------------------------------------------
option(WITH_EXTRA_TESTS "Run extra tests (usually only for developers)")
if(WITH_EXTRA_TESTS)
    add_test(NAME testinstall
             COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/test_install.cmake)
endif()

#-----------------------------------------------------------------------------

=== test/fileinfo/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - fileinfo
#
#-----------------------------------------------------------------------------

function(check_fileinfo _name _options _input _output)
    check_output(fileinfo ${_name} "fileinfo ${_options} fileinfo/${_input}" "fileinfo/${_output}")
endfunction()

#-----------------------------------------------------------------------------

check_fileinfo(fi1-extended "--extended --crc" fi1.osm fi1-result.txt)

add_test(NAME fileinfo-g-generator COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g header.option.generator)
set_tests_properties(fileinfo-g-generator PROPERTIES PASS_REGULAR_EXPRESSION "^testdata\n$")

add_test(NAME fileinfo-g-unknown-option COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g header.option.foo)
set_tests_properties(fileinfo-g-unknown-option PROPERTIES PASS_REGULAR_EXPRESSION "^$")

add_test(NAME fileinfo-g-fail COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g foobar)
set_tests_properties(fileinfo-g-fail PROPERTIES WILL_FAIL true)


#-----------------------------------------------------------------------------
# Test the metadata properties
#-----------------------------------------------------------------------------

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.version
add_test(NAME fileinfo-metadata-mixed-all-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.version)
set_tests_properties(fileinfo-metadata-mixed-all-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.timestamp
add_test(NAME fileinfo-metadata-mixed-all-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.timestamp)
set_tests_properties(fileinfo-metadata-mixed-all-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.changeset
add_test(NAME fileinfo-metadata-mixed-all-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.changeset)
set_tests_properties(fileinfo-metadata-mixed-all-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.version
add_test(NAME fileinfo-metadata-mixed-some-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.version)
set_tests_properties(fileinfo-metadata-mixed-some-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.timestamp
add_test(NAME fileinfo-metadata-mixed-some-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.timestamp)
set_tests_properties(fileinfo-metadata-mixed-some-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.changeset
add_test(NAME fileinfo-metadata-mixed-some-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.changeset)
set_tests_properties(fileinfo-metadata-mixed-some-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.uid
add_test(NAME fileinfo-metadata-mixed-some-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.uid)
set_tests_properties(fileinfo-metadata-mixed-some-uid PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.user
add_test(NAME fileinfo-metadata-mixed-some-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.user)
set_tests_properties(fileinfo-metadata-mixed-some-user PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.version
add_test(NAME fileinfo-metadata-homogenous-all-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.version)
set_tests_properties(fileinfo-metadata-homogenous-all-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.timestamp
add_test(NAME fileinfo-metadata-homogenous-all-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.timestamp)
set_tests_properties(fileinfo-metadata-homogenous-all-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.changeset
add_test(NAME fileinfo-metadata-homogenous-all-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.changeset)
set_tests_properties(fileinfo-metadata-homogenous-all-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.uid
add_test(NAME fileinfo-metadata-homogenous-all-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.uid)
set_tests_properties(fileinfo-metadata-homogenous-all-uid PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.user
add_test(NAME fileinfo-metadata-homogenous-all-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.user)
set_tests_properties(fileinfo-metadata-homogenous-all-user PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.version
add_test(NAME fileinfo-metadata-homogenous-some-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.version)
set_tests_properties(fileinfo-metadata-homogenous-some-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.timestamp
add_test(NAME fileinfo-metadata-homogenous-some-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.timestamp)
set_tests_properties(fileinfo-metadata-homogenous-some-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.changeset
add_test(NAME fileinfo-metadata-homogenous-some-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.changeset)
set_tests_properties(fileinfo-metadata-homogenous-some-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.uid
add_test(NAME fileinfo-metadata-homogenous-some-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.uid)
set_tests_properties(fileinfo-metadata-homogenous-some-uid PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.user
add_test(NAME fileinfo-metadata-homogenous-some-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.user)
set_tests_properties(fileinfo-metadata-homogenous-some-user PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

#-----------------------------------------------------------------------------

=== test/getparents/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - getparents
#
#-----------------------------------------------------------------------------

function(check_getparents _name _input _ids _output)
    check_output(getparents ${_name} "getparents --generator=test -f osm getparents/${_input} ${_ids}" "getparents/${_output}")
endfunction()

function(check_getparents_r _name _input _ids _output)
    check_output(getparents ${_name}-s "getparents --generator=test -f osm --add-self getparents/${_input} ${_ids}" "getparents/${_output}")
endfunction()

#-----------------------------------------------------------------------------

check_getparents(n10 input.osm n10 out-n10.osm)
check_getparents(n12 input.osm n12 out-n12.osm)
check_getparents(w20 input.osm w20 out-w20.osm)

check_getparents_r(n10 input.osm n10 out-n10-s.osm)
check_getparents_r(n12 input.osm n12 out-n12-s.osm)
check_getparents_r(w20 input.osm w20 out-w20-s.osm)


#-----------------------------------------------------------------------------

=== test/sort/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - sort
#
#-----------------------------------------------------------------------------

function(check_sort2 _name _in1 _in2 _output)
    check_output(sort ${_name} "sort --generator=test -f osm sort/${_in1} sort/${_in2}" "sort/${_output}")
endfunction()

function(check_sort1 _name _input _output _format)
    check_output(sort ${_name} "sort --generator=test -f ${_format} sort/${_input}" "sort/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_sort2(simple input-simple1.osm input-simple2.osm output-simple.osm)
check_sort2(bounds input-bounds1.osm input-bounds2.osm output-bounds.osm)
check_sort2(history input-history1.osm input-history2.osm output-history.osm)

check_sort1(neg input-neg.osm output-neg.osm osm)
check_sort1(change input-change.osc output-change.osc osc)

# Tests with limited metadata
check_sort2(simple-1-only-version input-simple1-only-version.osm input-simple2.osm output-simple-1-only-version.osm)
check_sort1(mixed-metadata input-simple-onefile.osm output-simple-onefile.osm osm)
check_sort1(history-partially-only-version input-history-partially-only-version.osm output-history-partially-only-version.osm osm)
check_sort1(history-only-version input-history-only-version.osm output-history-only-version.osm osm)

#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.9.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 18 Aug 2018 20:03:38 +0200

osmium-tool (1.9.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.0, no changes.
  * Bump minimum required libosmium2-dev to 2.14.2.
  * Update spelling-errors.patch to fix 'described' typo.
  * Update watch file to limit matches to archive path.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 12 Aug 2018 08:40:56 +0200

osmium-tool (1.8.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.5, no changes.
  * Strip trailing whitespace from control & rules files.
  * Use filter instead of findstring to prevent partial matches.
  * Update osmcode.org URLs to use HTTPS.
  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Aug 2018 10:52:52 +0200

osmium-tool (1.8.0-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright-format URL to use HTTPS.
  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.1.3, no changes.
  * Bump minimum required libosmium2-dev to 2.14.0.
  * Drop manpages-install.patch, applied upstream.
  * Update copyright years for Jochen Topf.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 31 Mar 2018 21:49:56 +0200

=== debian/control ===
Source: osmium-tool
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libboost-dev,
               libboost-program-options-dev,
               libbz2-dev,
               libexpat1-dev,
               libosmium2-dev (>= 2.14.2),
               pandoc,
               zlib1g-dev
Standards-Version: 4.2.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/osmium-tool/
Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git
Homepage: https://osmcode.org/osmium-tool/

Package: osmium-tool
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Command line tool for working with OpenStreetMap data
 Osmium Tool is a multipurpose command line tool based on the Osmium library.
 .
 With the Osmium Tool you currently can:
 .
  * Get information about an OSM file
  * Convert OSM files from one format into another (supports all XML and PBF
    formats)
  * Merge and apply change files to an OSM file (with or without history)
  * Extract data from OSM history files for a given point in time or a time
    range
 .
 The Osmium library has extensive support for all types of OSM entities: nodes,
 ways, relations, and changesets. It allows reading from and writing to OSM
 files in XML and PBF formats, including change files and full history files.
 Osmium can store OSM data in memory and on disk in various formats and using
 various indexes. Its easy to use handler interface allows you to quickly write
 data filtering and conversion functions. Osmium can create WKT, WKB, OGR, GEOS
 and GeoJSON geometries for easy conversion into many GIS formats and it can
 assemble multipolygons from ways and relations.

## osmium-tool 1.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,8 +25,8 @@
 project(osmium)
 
 set(OSMIUM_VERSION_MAJOR 1)
-set(OSMIUM_VERSION_MINOR 9)
-set(OSMIUM_VERSION_PATCH 1)
+set(OSMIUM_VERSION_MINOR 10)
+set(OSMIUM_VERSION_PATCH 0)
 
 set(OSMIUM_VERSION ${OSMIUM_VERSION_MAJOR}.${OSMIUM_VERSION_MINOR}.${OSMIUM_VERSION_PATCH})
 
@@ -44,7 +44,7 @@
 find_package(Boost 1.55.0 REQUIRED COMPONENTS program_options)
 include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
 
-find_package(Osmium 2.14.2 REQUIRED COMPONENTS io)
+find_package(Osmium 2.15.0 REQUIRED COMPONENTS io)
 include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS})
 
 
@@ -231,6 +231,7 @@
     util.cpp
     command_help.cpp
     export/export_format_json.cpp
+    export/export_format_pg.cpp
     export/export_format_text.cpp
     export/export_handler.cpp
     extract/extract_bbox.cpp

=== man/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  Optional "man" target to generate man pages
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for pandoc")
find_program(PANDOC pandoc)

function(add_man_page _section _name)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man${_section})
    set(_output_file ${CMAKE_CURRENT_BINARY_DIR}/man${_section}/${_name}.${_section})
    install(FILES ${_output_file} DESTINATION share/man/man${_section})
    set(_source_file ${CMAKE_CURRENT_SOURCE_DIR}/${_name}.md)
    set(_dest_file ${CMAKE_CURRENT_BINARY_DIR}/source/${_name}.md)
    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/common-options.md MAN_COMMON_OPTIONS)
    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/progress-options.md MAN_PROGRESS_OPTIONS)
    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/input-options.md MAN_INPUT_OPTIONS)
    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/output-options.md MAN_OUTPUT_OPTIONS)
    file(READ ${CMAKE_SOURCE_DIR}/export-example-config/default-config.json EXPORT_DEFAULT_CONFIG)
    configure_file(${_source_file} ${_dest_file} @ONLY)
    string(TOUPPER ${_name} _name_upcase)
    add_custom_command(OUTPUT ${_output_file}
        COMMAND ${PANDOC}
            ${PANDOC_MAN_OPTIONS}
            --variable "title=${_name_upcase}"
            --variable "section=${_section}"
            -o ${_output_file}
            ${_dest_file}
        DEPENDS ${_source_file} manpage.template common-options.md input-options.md output-options.md
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Building manpage ${_name}.${_section}"
        VERBATIM)
    set(ALL_MAN_PAGES "${ALL_MAN_PAGES};${_output_file}" PARENT_SCOPE)
endfunction()


if(PANDOC)
    message(STATUS "Looking for pandoc - found")
    message(STATUS "  Manual pages will be built")
    set(PANDOC_MAN_OPTIONS
        -s
        -t man
        --template ${CMAKE_CURRENT_SOURCE_DIR}/manpage.template
        --variable "description=osmium/${OSMIUM_VERSION}"
        --variable "version=${OSMIUM_VERSION}"
        --variable "author=${AUTHOR}"
    )

    add_man_page(1 osmium)
    add_man_page(1 osmium-add-locations-to-ways)
    add_man_page(1 osmium-apply-changes)
    add_man_page(1 osmium-cat)
    add_man_page(1 osmium-changeset-filter)
    add_man_page(1 osmium-check-refs)
    add_man_page(1 osmium-derive-changes)
    add_man_page(1 osmium-diff)
    add_man_page(1 osmium-export)
    add_man_page(1 osmium-extract)
    add_man_page(1 osmium-fileinfo)
    add_man_page(1 osmium-getid)
    add_man_page(1 osmium-getparents)
    add_man_page(1 osmium-merge)
    add_man_page(1 osmium-merge-changes)
    add_man_page(1 osmium-renumber)
    add_man_page(1 osmium-show)
    add_man_page(1 osmium-sort)
    add_man_page(1 osmium-tags-filter)
    add_man_page(1 osmium-time-filter)
    add_man_page(5 osmium-file-formats)
    add_man_page(5 osmium-index-types)

    add_custom_target(man ALL DEPENDS ${ALL_MAN_PAGES})
else()
    message(STATUS "Looking for pandoc - not found")
    message(STATUS "  Manual pages will not be built")
endif()

=== src/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

add_executable(osmium
    main.cpp
    commands.cpp
    ${PROJECT_BINARY_DIR}/src/version.cpp
    ${OSMIUM_SOURCE_FILES}
)

target_link_libraries(osmium ${Boost_LIBRARIES} ${OSMIUM_LIBRARIES})

set_pthread_on_target(osmium)

install(TARGETS osmium DESTINATION bin)

=== test/add-locations-to-ways/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - add-locations-to-ways
#
#-----------------------------------------------------------------------------

function(check_add_locations_to_ways _name _options _input _output)
    check_output(add-locations-to-ways ${_name} "add-locations-to-ways ${_options} --generator=test --output-header=xml_josm_upload=false --output-format=xml add-locations-to-ways/${_input}" "add-locations-to-ways/${_output}")
endfunction()

check_add_locations_to_ways(taggednodes "" input.osm output.osm)
check_add_locations_to_ways(allnodes "-n" input.osm output-n.osm)


#-----------------------------------------------------------------------------

=== test/export/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - export
#
#-----------------------------------------------------------------------------

function(check_export _name _options _input _output)
    check_output(export ${_name} "export ${_options} export/${_input}" "export/${_output}")
endfunction()

check_export(geojson    "-f geojson"       input.osm output.geojson)
check_export(geojsonseq "-f geojsonseq -r" input.osm output.geojsonseq)

check_export(missing-node "-f geojson"  input-missing-node.osm output-missing-node.geojson)

check_export(error-node "-f geojson -E" input-missing-node.osm none.geojson)
set_tests_properties(export-error-node PROPERTIES WILL_FAIL true)

check_export(invalid-area "-f geojson"  input-incomplete-relation.osm output-incomplete-relation.geojson)

check_export(error-area "-f geojson -E" input-incomplete-relation.osm none.geojson)
set_tests_properties(export-error-area PROPERTIES WILL_FAIL true)

#-----------------------------------------------------------------------------

check_export(c-empty-empty-n "-E -f text --keep-untagged -c export/config-empty-empty.json" way.osm way-all-n.txt)
set_tests_properties(export-c-empty-empty-n PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-empty   "-E -f text                 -c export/config-empty-empty.json" way.osm way-all.txt)
set_tests_properties(export-c-empty-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)

check_export(c-null-null  "-E -f text -c export/config-null-null.json" way.osm way-all.txt)
check_export(c-undefined  "-E -f text -c export/config-undefined.json" way.osm way-all.txt)

check_export(c-tag-empty  "-E -f text -c export/config-tag-empty.json" way.osm way-tag-empty.txt)
set_tests_properties(export-c-tag-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-tag  "-E -f text -c export/config-empty-tag.json" way.osm way-empty-tag.txt)
set_tests_properties(export-c-empty-tag PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-tag-tag    "-E -f text -c export/config-tag-tag.json"   way.osm way-tag-tag.txt)

check_export(c-tagx-empty "-E -f text -c export/config-tagx-empty.json" way.osm way-tagx-empty.txt)
set_tests_properties(export-c-tagx-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-tagx "-E -f text -c export/config-empty-tagx.json" way.osm way-empty-tagx.txt)
set_tests_properties(export-c-empty-tagx PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-tagx-tagx  "-E -f text -c export/config-tagx-tagx.json"  way.osm way-tagx-tagx.txt)

check_export(c-true-true   "-E -f text -c export/config-true-true.json"   way.osm way-all.txt)
check_export(c-false-false "-E -f text -c export/config-false-false.json" way.osm way-none.txt)

check_export(c-null-tag    "-E -f text -c export/config-null-tag.json" way.osm way-null-tag.txt)
check_export(c-tag-null    "-E -f text -c export/config-tag-null.json" way.osm way-tag-null.txt)

#-----------------------------------------------------------------------------

=== test/getid/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - getid
#
#-----------------------------------------------------------------------------

function(check_getid _name _input _output)
    check_output(getid ${_name} "getid --generator=test --output-header=xml_josm_upload=false -f osm getid/${_input} n11,n12 w21" "getid/${_output}")
endfunction()

function(check_getid_file _name _file _input _output)
    check_output(getid ${_name} "getid --generator=test --output-header=xml_josm_upload=false -i getid/${_file} -f osm getid/${_input}" "getid/${_output}")
endfunction()

check_getid(n input.osm output.osm)
check_getid_file(file1 idfile input.osm output-file.osm)

#-----------------------------------------------------------------------------

function(check_getid_r _name _source _input _output)
    check_output(getid ${_name}   "getid -r --generator=test -f osm getid/${_source}.osm -I getid/${_input}.osm" "getid/${_output}.osm")
    check_output(getid ${_name}-i "getid -r --generator=test -f osm getid/${_source}.osm -i getid/${_input}.id"  "getid/${_output}.osm")
endfunction()

check_getid_r(n10 source in10 out10)
check_getid_r(w21 source in21 out21)
check_getid_r(r30 source in30 out30)
check_getid_r(r31 source in31 out31)
check_getid_r(r32 source in32 out32)

check_getid_r(n10nrr source-no-rr in10 out10)
check_getid_r(w21nrr source-no-rr in21 out21)
check_getid_r(r30nrr source-no-rr in30 out30)
check_getid_r(r32nrr source-no-rr in32 out32)

check_getid_r(missing-n19 source in19 out31)
set_tests_properties(getid-missing-n19 PROPERTIES WILL_FAIL true)
set_tests_properties(getid-missing-n19-i PROPERTIES WILL_FAIL true)

check_getid_r(missing-w29 source in29 out31)
set_tests_properties(getid-missing-w29 PROPERTIES WILL_FAIL true)
set_tests_properties(getid-missing-w29-i PROPERTIES WILL_FAIL true)

check_getid_r(missing-r39 source in39 out31)
set_tests_properties(getid-missing-r39 PROPERTIES WILL_FAIL true)
set_tests_properties(getid-missing-r39-i PROPERTIES WILL_FAIL true)

check_getid_r(relloop relloop relloop relloop-out)


#-----------------------------------------------------------------------------

=== test/merge-changes/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - merge-changes
#
#-----------------------------------------------------------------------------

function(check_merge_changes _name _options _in1 _in2 _output)
    check_output(merge-changes ${_name} "merge-changes ${_options} --generator=test -f osc merge-changes/${_in1} merge-changes/${_in2}" "merge-changes/${_output}")
endfunction()

# Both input files have all metadata attributes
check_merge_changes(merged "" change1.osc change2.osc merged.osc)
check_merge_changes(simplified "--simplify" change1.osc change2.osc simplified.osc)

# Both input files have only version attributes
check_merge_changes(merged-both-version "" change1-only-version.osc change2-only-version.osc merged-both-only-version.osc)
check_merge_changes(simplified-both-version "--simplify" change1-only-version.osc change2-only-version.osc simplified-both-only-version.osc)

# The first input file has only version attributes
check_merge_changes(merged-first-only-version "" change1-only-version.osc change2.osc merged-first-only-version.osc)
check_merge_changes(simplified-first-only-version "--simplify" change1-only-version.osc change2.osc simplified-first-only-version.osc)

# The second input file has only version attributes
check_merge_changes(merged-second-only-version "" change1.osc change2-only-version.osc merged-second-only-version.osc)
check_merge_changes(simplified-second-only-version "--simplify" change1.osc change2-only-version.osc simplified-second-only-version.osc)

#-----------------------------------------------------------------------------

=== test/merge/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - merge
#
#-----------------------------------------------------------------------------

function(check_merge1 _name _input1 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1}" "merge/${_output}")
endfunction()

function(check_merge2 _name _input1 _input2 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1} merge/${_input2}" "merge/${_output}")
endfunction()

function(check_merge3 _name _input1 _input2 _input3 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1} merge/${_input2} merge/${_input3}" "merge/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_merge1(i1 input1.osm output1.osm)
check_merge2(i2f input1.osm input2.osm output2.osm)
check_merge2(i2r input2.osm input1.osm output2.osm)
check_merge3(i3f input1.osm input2.osm input3.osm output3.osm)

# If both input files do not have timestamp attributes
check_merge2(i2f-only-version input1-only-version.osm input2-only-version.osm output2-12-only-version.osm)
check_merge2(i2r-only-version input2-only-version.osm input1-only-version.osm output2-12-only-version.osm)

#-----------------------------------------------------------------------------

=== test/misc/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - misc
#
#-----------------------------------------------------------------------------

do_test(version1 "osmium --version" "^osmium version ${OSMIUM_VERSION}")
do_test(version2 "osmium version"   "^osmium version ${OSMIUM_VERSION}")

do_test(unknown_command "osmium x" "^Unknown command or option 'x'. Try 'osmium help'.\n")


#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.10.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches, included upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 10 Dec 2018 16:54:26 +0100

osmium-tool (1.9.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.2.1, no changes.
  * Add upstream patches to fix FTBFS with libosmium 2.15.0.
    (closes: #916109)
  * Bump minimum required libosmium2-dev to 2.15.0.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 10 Dec 2018 12:20:36 +0100

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
                libboost-program-options-dev,
                libbz2-dev,
                libexpat1-dev,
-               libosmium2-dev (>= 2.14.2),
+               libosmium2-dev (>= 2.15.0),
                pandoc,
                zlib1g-dev
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osmium-tool/
 Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git
 Homepage: https://osmcode.org/osmium-tool/

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Verbose make output
export VERBOSE=1

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --buildsystem cmake \
	      --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_VERBOSE_MAKEFILE=1

override_dh_auto_test:
# Ignore test failures on problematic architectures only
ifneq (,$(filter $(DEB_BUILD_ARCH),mips mips64el mipsel))
	dh_auto_test || echo "Ignoring test failures"
else
	dh_auto_test
endif

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md
